//平均曝光
//参考了SEUS
float calculateAverageLuminance() {
    int samplerLod = int(log2(min(viewWidth, viewHeight)));
    return getLuminance(colortex4, CENTER_COORD, samplerLod);
}

void avgExposure(inout vec3 color) {
    float avgLuminance = calculateAverageLuminance() + 0.01;

    float targetLuminance = 2.5;
    float exposureScale = 0.15;

    float exposure = pow(targetLuminance / avgLuminance, exposureScale);

    color *= exposure;
}

#ifdef FINAL
void avgExposure1(inout vec3 color) {
    float avgLuminance = texelFetch(colortex2, ivec2(0, 0), 0).a;
    float t = TARGET_BRIGHTNESS;
    float d = EXPOSURE_DELTA;
    float s = LIGHT_SENSITIVITY;
    // float s = mix(LIGHT_SENSITIVITY * 0.3, LIGHT_SENSITIVITY, isNoon);
    float exposure = pow(mix(1.0, t / (avgLuminance + 0.01), d), s);
    color *= exposure;
    // color = vec3(avgLuminance);
}
#endif
