#ifdef GBF_VSH

float IDMapping(){
    switch(int(mc_Entity.x + 0.1)){
        case 31:            return PLANTS_SHORT;
        case 10175:         return PLANTS_TALL_L;
        case 11175:         return PLANTS_TALL_U;
        case 18:            return LEAVES;
        case 10176:         return PLANTS_OTHER;
        case 89:            return GLOWING_BLOCK;

        default:            return 0.0;
    }
}

// translucency
float IDMappingT(){
    switch(int(mc_Entity.x + 0.1)){
        case 8:             return WATER;
        
        default:            return 0.0;
    }
}

#endif

#ifdef CPS_FSH
    vec2 tTexcoord = unTAAJitterTexcoord(texcoord);
    float ID = texture(colortex1, texcoord.st).r;
    float blockID = unpack16Bit(ID).x * BLOCK_SCALE;
    float gbfID = unpack16Bit(ID).y * BLOCK_SCALE;



    float gbfIDRange = 0.3;
    float gbfTerrain = checkInRange(gbfID, GBF_TERRAIN, gbfIDRange);
    float gbfEntities = checkInRange(gbfID, GBF_ENTITIES, gbfIDRange);
    


    // float blockIDRange = gbfEntities > 0.5 ? -1.0 : 0.3;
    float blockIDRange = 0.3;
    float plantsS   = checkInRange(blockID, PLANTS_SHORT, blockIDRange);
    float plantsTL  = checkInRange(blockID, PLANTS_TALL_L, blockIDRange);
    float plantsTU  = checkInRange(blockID, PLANTS_TALL_U, blockIDRange);
    float plantsT   = plantsTL + plantsTU;
    float leaves   = checkInRange(blockID, LEAVES, blockIDRange);
    float plantsO = checkInRange(blockID, PLANTS_OTHER, blockIDRange);
    float plants   = plantsS + plantsT + leaves + plantsO;

    float glowingB = checkInRange(blockID, GLOWING_BLOCK, blockIDRange);
    // float ice = checkInRange(blockID, ICE, blockIDRange);



    // 用于方块判断的深度
    // float depthB = texture(depthtex0, texcoord.st).r;
    float depthB1 = texture(depthtex1, texcoord.st).r;
    // float depthB1H = texture(depthtex1, texcoord * 2.0).r;

    // H 半分辨率，1 depthtex1 
    // vec2 hrrUVB = texcoord * 2.0;
    // vec2 unTAAHrrUVB = unTAAJitterTexcoord(texcoord) * 2.0;
    // float depthH10 = texture(depthtex1, hrrUVB).r;
    // float depthH11 = texture(depthtex1, hrrUVB + vec2(-1.0 / viewWidth, -1.0 / viewHeight)).r;
    // float depthH12 = texture(depthtex1, hrrUVB + vec2(-1.0 / viewWidth, 1.0 / viewHeight)).r;
    // float depthH13 = texture(depthtex1, hrrUVB + vec2(1.0 / viewWidth, 1.0 / viewHeight)).r;
    // float depthH14 = texture(depthtex1, hrrUVB + vec2(1.0 / viewWidth, -1.0 / viewHeight)).r;

    // float skyA = depthB == 1.0 ? 1.0 : 0.0;
    float skyB = depthB1 == 1.0 ? 1.0 : 0.0;
    // float skyC = ((depthH10 == 1.0)||(depthH11 == 1.0)||(depthH12 == 1.0)||(depthH13 == 1.0)||(depthH14 == 1.0)) ? 1.0 : 0.0;
    // float skyD = depthB1H > 0.999 ? 1.0 : 0.0;

    // float landC = ((depthH10 < 1.0)||(depthH11 < 1.0)||(depthH12 < 1.0)||(depthH13 < 1.0)||(depthH14 < 1.0)) ? 1.0 : 0.0;

    // float CT6_A = texture(colortex6, texcoord).a;
    float CT7 = unpack16Bit(texture(colortex7, texcoord).b).y;
    float waterA = (CT7 > 0.2/*||CT6_A > 0.90*/) ? 1.0 : 0.0;
    // float waterB = CT7_A < 0.6 || CT7_A > 1.5 ? 1.0 : 0.0;
    // float waterC = waterB - waterA;

#endif
