//varying
varying vec2 lmcoord;
varying vec4 glcolor;

#include "/lib/uniform.glsl"
#include "/lib/setting.glsl"
#include "/lib/common/common.glsl"

#ifdef FSH

void main() {
	vec4 color = glcolor;
	// color *= texture(lightmap, lmcoord);

/* DRAWBUFFERS:0 */
	gl_FragData[0] = vec4(color.rgb, color.a);
}

#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef VSH
#include "/lib/TAA.glsl"

void main() {
	gl_Position = ftransform();
	vec2 jitter = Halton_2_3[frameCounter % 8];	//-1 to 1
	jitter /= vec2(viewWidth, viewHeight);

	gl_Position.xyz /= gl_Position.w;
    gl_Position.xy += jitter * TAA_JITTER_AMOUNT;
    gl_Position.xyz *= gl_Position.w;
	
	lmcoord  = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	glcolor = gl_Color;
}
#endif