vec2 AdjustLightmap(vec2 mcLightmap){
    mcLightmap = (mcLightmap * 33.05 - 1.05) / 32.0;
    gammaToLinear(mcLightmap);
    
    // 人造光
    mcLightmap.x = clamp01(1 * pow(mcLightmap.x, 2.0));

    // 环境光
    mcLightmap.y = clamp01(pow(mcLightmap.y, 1.15));

    return mcLightmap;
}