uniform sampler2D lightmap;
uniform sampler2D tex;
uniform sampler2D noisetex;
uniform sampler2D shadowtex0;
uniform sampler2DShadow shadowtex1;
uniform sampler2D shadowcolor0;
uniform sampler2D shadowcolor1;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D normals;
uniform sampler2D specular;

uniform ivec2 atlasSize;

uniform sampler2D colortex0;
uniform sampler2D colortex1;
uniform sampler2D colortex2;
uniform sampler2D colortex3;
uniform sampler2D colortex4;
uniform sampler2D colortex5;
uniform sampler2D colortex6;
uniform sampler2D colortex7;

uniform vec4 entityColor;
uniform vec3 fogColor;
uniform vec3 skyColor;



uniform float far;
uniform float near;
uniform float viewWidth;
uniform float viewHeight; 
vec2 texResolution = vec2(viewWidth, viewHeight);

uniform mat4 gbufferModelView;
uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;
uniform mat4 gbufferPreviousProjection;

uniform mat4 shadowModelView;
uniform mat4 shadowProjection;
uniform mat4 shadowModelViewInverse;
uniform mat4 shadowProjectionInverse;
mat4 shadowMat = shadowProjection * shadowModelView;

uniform vec3 upPosition;
uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;
uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform vec3 shadowLightPosition;
vec3 upWorldDir = vec3(0.0, 1.0, 0.0);



uniform int isEyeInWater;

uniform ivec2 eyeBrightness;
uniform ivec2 eyeBrightnessSmooth;
uniform float nightVision;

uniform int worldTime;
uniform int frameCounter;
uniform float frameTime;  
uniform float frameTimeCounter;
uniform float rainStrength;
