varying vec2 texcoord;

#include "/lib/uniform.glsl"
#include "/lib/setting.glsl"
#include "/lib/common/common.glsl"
#include "/lib/common/position.glsl"
// #include "/lib/camera/colorToolkit.glsl"
// #include "/lib/common/noise.glsl"

#ifdef FSH
// const bool colortex0MipmapEnabled = true;
const bool colortex4MipmapEnabled = true;

#define CPS_FSH
#include "/lib/camera/filter.glsl"
#include "/lib/camera/bloom.glsl"

void main() {

	//bloom横向下采样
    vec3 blur = vec3(0.0);
	// blur += horizontalDownSampling(colortex4, texcoord, 1.0);
    blur += horizontalDownSampling(colortex4, texcoord, 2.0);
	blur += horizontalDownSampling(colortex4, texcoord, 3.0);
	blur += horizontalDownSampling(colortex4, texcoord, 4.0);
	blur += horizontalDownSampling(colortex4, texcoord, 5.0);
	blur += horizontalDownSampling(colortex4, texcoord, 6.0);
	blur += horizontalDownSampling(colortex4, texcoord, 7.0);
	blur += horizontalDownSampling(colortex4, texcoord, 8.0);

/* DRAWBUFFERS:4 */
	gl_FragData[0] = vec4(blur, 1.0);
}


#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef VSH

void main() {
	gl_Position = ftransform();
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
}
#endif